/*!
 * Copyright (c) 2012 - 2021, Anaconda, Inc., and Bokeh Contributors
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution.
 * 
 * Neither the name of Anaconda nor the names of any contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
(function(root, factory) {
  factory(root["Bokeh"], undefined);
})(this, function(Bokeh, version) {
  var define;
  return (function(modules, entry, aliases, externals) {
    const bokeh = typeof Bokeh !== "undefined" && (version != null ? Bokeh[version] : Bokeh);
    if (bokeh != null) {
      return bokeh.register_plugin(modules, entry, aliases);
    } else {
      throw new Error("Cannot find Bokeh " + version + ". You have to load it prior to loading plugins.");
    }
  })
({
"b5bf9b8817": function _(e,s,o,t,i){t();const a=e("tslib").__importStar(e("88dea9ae8f"));o.VizModels=a;e("@bokehjs/base").register_models(a)},
"88dea9ae8f": function _(e,r,o,t,f){t(),f("OffsetLogColorMapper",e("31d02535b8").OffsetLogColorMapper),f("OffsetLogTickFormatter",e("3571f5e394").OffsetLogTickFormatter),f("ThrottledSlider",e("c7269ba5d4").ThrottledSlider),f("Tree",e("342f084289").Tree)},
"31d02535b8": function _(o,e,t,l,r){l();const s=o("@bokehjs/models/mappers/log_color_mapper"),a=o("@bokehjs/core/util/arrayable");class n extends s.LogColorMapper{constructor(o){super(o)}static init_OffsetLogColorMapper(){this.define((({Array:o,Number:e})=>({log_span:[o(e),[1,10]]})))}scan(o,e){let t=null!=this.low?this.low:a.min(o),l=null!=this.high?this.high:a.max(o),r=null!=this.log_span?this.log_span:[1,10];const s=[t,l],n=e/(Math.log(r[1])-Math.log(r[0]));return{max:r[1],min:r[0],scale:n,interval:s}}cmap(o,e,t,l,r){const s=e.length-1;let a=r.max,n=r.min,i=r.interval;if((o=n+(a-n)/(i[1]-i[0])*(o-i[0]))>a)return l;if(o==a)return e[s];if(o<n)return t;const p=Math.log(o)-Math.log(n);let h=Math.floor(p*r.scale);return h>s&&(h=s),e[h]}}t.OffsetLogColorMapper=n,n.__name__="OffsetLogColorMapper",n.__module__="pyscivis.visualizer.models.offset_log_color_mapper",n.init_OffsetLogColorMapper()},
"3571f5e394": function _(t,o,r,s,i){s();const e=t("@bokehjs/models/formatters/log_tick_formatter"),a=t("@bokehjs/core/util/arrayable");class _ extends e.LogTickFormatter{constructor(t){super(t)}static init_OffsetLogTickFormatter(){this.define((({Array:t,Number:o})=>({low:[o,0],high:[o,0],log_span:[t(o),[1,10]]})))}format_graphics(t,o){if(0==t.length)return[];const r=a.min(this.log_span),s=a.max(this.log_span);return t=t.map((t=>this.low+(this.high-this.low)/(s-r)*(t-r))),this.basic_formatter.format_graphics(t,o)}}r.OffsetLogTickFormatter=_,_.__name__="OffsetLogTickFormatter",_.__module__="pyscivis.visualizer.models.offset_log_tick_formatter",_.init_OffsetLogTickFormatter()},
"c7269ba5d4": function _(e,d,l,s,i){s();const t=e("@bokehjs/models/widgets/slider");class _ extends t.Slider{}l.ThrottledSlider=_,_.__name__="ThrottledSlider",_.__module__="pyscivis.visualizer.models.throttled_slider"},
"342f084289": function _(e,i,n,t,l){t();const d=e("@bokehjs/models/widgets/widget");class o extends d.WidgetView{render(){$(this.el).on("select_node.jstree",((e,i)=>{var n=i.instance.get_node(i.selected[0]);["images","header","acquisitions"].includes(n.type)&&(this.model.selected=[n.parent,n.id,n.type])})).on("loaded.jstree",(()=>{$(this.el).jstree("open_all")})).jstree(this.get_data())}get_data(){return{types:{images:{valid_children:"none",icon:"glyphicon glyphicon-picture"},acquisitions:{valid_children:"none",icon:"glyphicon glyphicon-list"},header:{valid_children:"none",icon:"glyphicon glyphicon-file"},container:{valid_children:["folder","image","acquisition","header"],icon:"glyphicon glyphicon-folder-open"},file:{valid_children:["folder","image","acquisition","header"],icon:"glyphicon glyphicon-hdd"},default:{valid_children:["folder","image","acquisition","header"],icon:"glyphicon glyphicon-question-sign"}},core:{multiple:!1,data:this.model.tree,themes:{name:"dark"==this.model.theme?"default-dark":"default",dots:!0,icons:!0}},plugins:["types"]}}}n.TreeView=o,o.__name__="TreeView";class s extends d.Widget{constructor(e){super(e)}static init_Tree(){this.prototype.default_view=o,this.define((({Tuple:e,String:i,Any:n})=>({selected:[e(i,i,i)],theme:[i],tree:[n]})))}}n.Tree=s,s.__name__="Tree",s.__module__="pyscivis.visualizer.models.filetree",s.init_Tree()},
}, "b5bf9b8817", {"index":"b5bf9b8817","visualizer/models/index":"88dea9ae8f","visualizer/models/offset_log_color_mapper":"31d02535b8","visualizer/models/offset_log_tick_formatter":"3571f5e394","visualizer/models/throttled_slider":"c7269ba5d4","visualizer/models/filetree":"342f084289"}, {});});
